/**
 * A collection of sorting algorithms for arrays of integers.
 * 
 * @author Stefan Nilsson 
 * @version 2004-10-29
 */
public class Sort
{ 
    /**
     * Default constructor.
     */
    public Sort()
    {
    }

    /**
     * Sort the elements in ascending order using selection sort.
     * This algorithm has time complexity Theta(n*n), where n is
     * the length of the array.
     * 
     * @param  v   An array of integers.
     * @return     The same array sorted in ascending order.
     */
    public void selectionSort(int[] v)
    {
         int n = v.length;
         for (int i = 0; i < n - 1; i++) {
             // find index m of min element in v[i..n-1]  
             int m = i;
             for (int j = i + 1; j < n; j++) {
                 if (v[j] < v[m])
                     m = j;
             }
             // swap v[i] and v[m]
             int temp = v[i];
             v[i] = v[m];
             v[m] = temp;
         }
    }
 }