 import java.util.Arrays;
 import java.util.Random;
 
 /**
 * Test class for Sort.
 *
 * @author  Stefan Nilsson
 * @version 2004-10-29
 */
public class SortTest extends junit.framework.TestCase
{
    // t: test case,  s: expected solution.
    private int[] t0, s0, t1, s1, t2, s2, t7, s7;
    
    // Big array of random numbers.
    // tr: test case, sr: expected solution.
    // R_SIZE is the size of the array.
    private static final int R_SIZE = 10000;
    private int[] tr, sr;
    
    private Random rand;

    /**
     * Default constructor.
     */
    public SortTest()
    {
        rand = new Random();
    }

    /**
     * Sets up the test fixture.
     *
     * Called before every test case method.
     */
    protected void setUp()
    {
        t0 = new int[0];
        s0 = new int[0];
 
        t1 = new int[1];
        s1 = new int[1];
        t1[0] = s1[0] = 1;
       
        t2 = new int[2];
        s2 = new int[2];
        t2[0] = s2[1] = 2;
        t2[1] = s2[0] = 1;
        
        t7 = new int[7];
        s7 = new int[7];
        t7[0] = s7[6] = 9;
        t7[1] = s7[2] = 5;
        t7[2] = s7[1] = 2;
        t7[3] = s7[5] = 7;
        t7[4] = s7[0] = 1;
        t7[5] = s7[3] = 6;
        t7[6] = s7[4] = 6;
        
        tr = new int[R_SIZE];
        sr = new int[R_SIZE];
        for (int i = 0; i < R_SIZE; i++)
            tr[i] = sr[i] = rand.nextInt();
        Arrays.sort(sr);
    }

    /**
     * Tears down the test fixture.
     *
     * Called after every test case method.
     */
    protected void tearDown()
    {
    }

    public void testSelectionSort()
    {
        Sort sort = new Sort();     
        sort.selectionSort(t0);
        assertTrue(Arrays.equals(t0, s0));      
        sort.selectionSort(t1);
        assertTrue(Arrays.equals(t1, s1));      
        sort.selectionSort(t2);
        assertTrue(Arrays.equals(t2, s2));      
        sort.selectionSort(t7);
        assertTrue(Arrays.equals(t7, s7));      
        sort.selectionSort(tr);
        assertTrue(Arrays.equals(tr, sr));
    }
}